﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.ComponentModel;

namespace WebDataGrid.App_Code {

    [DataObject]
    public class Master {

        private static MasterData[] dataArray = new MasterData[] {
            new MasterData { Key = 0, Count = 10, Description = "First" },
            new MasterData { Key = 1, Count = 33, Description = "Second", Approvable = true },
            new MasterData { Key = 2, Count = 85, Description = "Third", Approvable = true }
        };

        private static List<MasterData> DataList {
            get {
                return dataList ?? (dataList = dataArray.ToList());
            }
        }
        private static List<MasterData> dataList;
        private static int nextKey = 3;

        [DataObjectMethod(DataObjectMethodType.Select, true)]
        public List<MasterData> geDataList() {
            return DataList;
        }

        [DataObjectMethod(DataObjectMethodType.Insert, true)]
        public void insertMaster(int count, string description) { //Approvable is read-only
            DataList.Add(new MasterData { Key = nextKey++, Count = count, Description = description });
        }

        [DataObjectMethod(DataObjectMethodType.Update, true)]
        public void updateMaster(int Key, int count, string description) {
            var data = DataList.Where(d => d.Key == Key).First();
            data.Count = count;
            data.Description = description;
        }

        [DataObjectMethod(DataObjectMethodType.Delete, true)]
        public void deleteMaster(int Key) {
            DataList.Remove(DataList.Where(d => d.Key == Key).First());
        }

        [DataObjectMethod(DataObjectMethodType.Select)]
        public MasterData[] getDataArray() {
            return dataArray;
        }
    }

    public class MasterData {
        public int Key { get; set; }
        public int Count { get; set; }
        public string Description { get; set; }
        public bool Approvable { get; set; }
    }
}
